#include "bits/stdc++.h"

using namespace std;

int main() {
  // Wczytujemy dane z wejścia.
  int N;
  cin >> N;
  vector <int> T(N+1);
  for (int i=1; i<=N; i++) cin >> T[i];

  // Tworzymy tablicę zaznaczone, w której będziemy zapmiętywać kiedy odwiedziliśmy
  // dany poziom.
  vector <int> zaznaczone(N+1);
  // Ustalamy wynik na odpowiednią dużą liczbę, wiemy że wynik będzie mniejszy niż N*N.
  long long wynik = (long long)N * N;

  // Dla każdego poziomu od 1 do N.
  for (int i=1; i<=N; i++) {
    // Jeżeli poziom i nie był jeszcze odwiedzony.
    if (zaznaczone[i] == 0) {
      int aktualny = i;
      // Dopóki nie trafimy do już wcześniej odwiedzonego poziomu.
      while (zaznaczone[aktualny] == 0) {
        // Zazancz poziom jako odwiedzony.
        zaznaczone[aktualny] = i;
        // I przejdź do kolejnego.
        aktualny = T[aktualny];
      }
      // Kiedy weszliśmy do tego samego poziomu w tym samym przejściu,
      // to znaczy że jesteśmy na cyklu.
      if (zaznaczone[aktualny] == i) {
        // Musimy policzyć sumę indeksów na tym cyklu.
        long long suma_na_cyklu = 0;
        // Zapamiętujemy gdzie znajduje się koniec cyklu.
        int koniec_cyklu = aktualny;
        // Przechodzimy ponownie po cyklu i dodajemy numery indeksów.
        do {
          suma_na_cyklu += aktualny;
          aktualny = T[aktualny];
        } while (koniec_cyklu != aktualny);
        // Na końcu bierzemy wynik z wyniku i sumy na tym cyklu.
        wynik = min(suma_na_cyklu, wynik);
      }
    }
  }
  cout << wynik << "\n";
}
